/* Application.c generated by valac 0.48.6, the Vala compiler
 * generated from Application.vala, do not modify */

/*-
 * Copyright (c) 2013-2018 elementary LLC (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 *              Cody Garver <cody@elementaryos.org>
 *              Artem Anufrij <artem.anufrij@live.de>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <locale.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <clutter/clutter.h>
#include <clutter-gtk/clutter-gtk.h>
#include <gst/gst.h>

#define AUDIENCE_TYPE_APP (audience_app_get_type ())
#define AUDIENCE_APP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_APP, AudienceApp))
#define AUDIENCE_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_APP, AudienceAppClass))
#define AUDIENCE_IS_APP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_APP))
#define AUDIENCE_IS_APP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_APP))
#define AUDIENCE_APP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_APP, AudienceAppClass))

typedef struct _AudienceApp AudienceApp;
typedef struct _AudienceAppClass AudienceAppClass;
typedef struct _AudienceAppPrivate AudienceAppPrivate;

#define AUDIENCE_TYPE_WINDOW (audience_window_get_type ())
#define AUDIENCE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindow))
#define AUDIENCE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))
#define AUDIENCE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_WINDOW))
#define AUDIENCE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_WINDOW, AudienceWindowClass))

typedef struct _AudienceWindow AudienceWindow;
typedef struct _AudienceWindowClass AudienceWindowClass;
enum  {
	AUDIENCE_APP_0_PROPERTY,
	AUDIENCE_APP_NUM_PROPERTIES
};
static GParamSpec* audience_app_properties[AUDIENCE_APP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AudienceApp {
	GtkApplication parent_instance;
	AudienceAppPrivate * priv;
	AudienceWindow* mainwindow;
	GVolumeMonitor* monitor;
};

struct _AudienceAppClass {
	GtkApplicationClass parent_class;
};

extern GSettings* audience_settings;
GSettings* audience_settings = NULL;
static gpointer audience_app_parent_class = NULL;
static AudienceApp* audience_app_app;
static AudienceApp* audience_app_app = NULL;

#define AUDIENCE_SCHEMA "io.elementary.videos"
GType audience_app_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceApp, g_object_unref)
GType audience_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceWindow, g_object_unref)
AudienceApp* audience_app_new (void);
AudienceApp* audience_app_construct (GType object_type);
void audience_services_inhibitor_initialize (GtkApplication* _application);
AudienceApp* audience_app_get_instance (void);
static void audience_app_real_activate (GApplication* base);
gchar* audience_app_get_cache_directory (AudienceApp* self);
AudienceWindow* audience_window_new (void);
AudienceWindow* audience_window_construct (GType object_type);
static void audience_app_real_open (GApplication* base,
                             GFile** files,
                             gint files_length1,
                             const gchar* hint);
void audience_window_open_files (AudienceWindow* self,
                                 GFile** files,
                                 gint files_length1,
                                 gboolean clear_playlist_items,
                                 gboolean force_play);
static GObject * audience_app_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void audience_app_finalize (GObject * obj);
static GType audience_app_get_type_once (void);
void _vala_main (gchar** args,
                 gint args_length1);

AudienceApp*
audience_app_construct (GType object_type)
{
	AudienceApp * self = NULL;
	GtkSettings* _tmp0_;
	GApplicationFlags _tmp1_;
	GApplicationFlags _tmp2_;
	GSettings* _tmp3_;
	self = (AudienceApp*) g_object_new (object_type, NULL);
	_tmp0_ = gtk_settings_get_default ();
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", TRUE, NULL);
	_tmp1_ = g_application_get_flags ((GApplication*) self);
	_tmp2_ = _tmp1_;
	g_application_set_flags ((GApplication*) self, _tmp2_ | G_APPLICATION_HANDLES_OPEN);
	_tmp3_ = g_settings_new (AUDIENCE_SCHEMA);
	_g_object_unref0 (audience_settings);
	audience_settings = _tmp3_;
	audience_services_inhibitor_initialize ((GtkApplication*) self);
	return self;
}

AudienceApp*
audience_app_new (void)
{
	return audience_app_construct (AUDIENCE_TYPE_APP);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

AudienceApp*
audience_app_get_instance (void)
{
	AudienceApp* _tmp0_;
	AudienceApp* _tmp2_;
	AudienceApp* _tmp3_;
	AudienceApp* result = NULL;
	_tmp0_ = audience_app_app;
	if (_tmp0_ == NULL) {
		AudienceApp* _tmp1_;
		_tmp1_ = audience_app_new ();
		_g_object_unref0 (audience_app_app);
		audience_app_app = _tmp1_;
	}
	_tmp2_ = audience_app_app;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static void
audience_app_real_activate (GApplication* base)
{
	AudienceApp * self;
	AudienceWindow* _tmp0_;
	GError* _inner_error0_ = NULL;
	self = (AudienceApp*) base;
	_tmp0_ = self->mainwindow;
	if (_tmp0_ == NULL) {
		GSettings* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gboolean _tmp4_;
		GFile* library_folder = NULL;
		GSettings* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		gboolean _tmp12_ = FALSE;
		GFile* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gboolean _tmp16_;
		AudienceWindow* _tmp28_;
		AudienceWindow* _tmp29_;
		AudienceWindow* _tmp30_;
		_tmp1_ = audience_settings;
		_tmp2_ = g_settings_get_string (_tmp1_, "last-folder");
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strcmp0 (_tmp3_, "-1") == 0;
		_g_free0 (_tmp3_);
		if (_tmp4_) {
			GSettings* _tmp5_;
			const gchar* _tmp6_;
			_tmp5_ = audience_settings;
			_tmp6_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
			g_settings_set_string (_tmp5_, "last-folder", _tmp6_);
		}
		_tmp7_ = audience_settings;
		_tmp8_ = g_settings_get_string (_tmp7_, "library-folder");
		_tmp9_ = _tmp8_;
		_tmp10_ = g_file_new_for_path (_tmp9_);
		_tmp11_ = _tmp10_;
		_g_free0 (_tmp9_);
		library_folder = _tmp11_;
		_tmp13_ = library_folder;
		_tmp14_ = g_file_get_path (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = g_strcmp0 (_tmp15_, "") == 0;
		_g_free0 (_tmp15_);
		if (_tmp16_) {
			_tmp12_ = TRUE;
		} else {
			GFile* _tmp17_;
			_tmp17_ = library_folder;
			_tmp12_ = !g_file_query_exists (_tmp17_, NULL);
		}
		if (_tmp12_) {
			GSettings* _tmp18_;
			const gchar* _tmp19_;
			_tmp18_ = audience_settings;
			_tmp19_ = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
			g_settings_set_string (_tmp18_, "library-folder", _tmp19_);
		}
		{
			GFile* cache = NULL;
			gchar* _tmp20_;
			gchar* _tmp21_;
			GFile* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			_tmp20_ = audience_app_get_cache_directory (self);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_file_new_for_path (_tmp21_);
			_tmp23_ = _tmp22_;
			_g_free0 (_tmp21_);
			cache = _tmp23_;
			_tmp24_ = cache;
			if (!g_file_query_exists (_tmp24_, NULL)) {
				GFile* _tmp25_;
				_tmp25_ = cache;
				g_file_make_directory (_tmp25_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (cache);
					goto __catch0_g_error;
				}
			}
			_g_object_unref0 (cache);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp26_;
			const gchar* _tmp27_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp26_ = e;
			_tmp27_ = _tmp26_->message;
			g_warning ("Application.vala:70: %s", _tmp27_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (library_folder);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp28_ = audience_window_new ();
		g_object_ref_sink (_tmp28_);
		_g_object_unref0 (self->mainwindow);
		self->mainwindow = _tmp28_;
		_tmp29_ = self->mainwindow;
		gtk_window_set_application ((GtkWindow*) _tmp29_, (GtkApplication*) self);
		_tmp30_ = self->mainwindow;
		gtk_window_set_title ((GtkWindow*) _tmp30_, _ ("Videos"));
		_g_object_unref0 (library_folder);
	}
}

gchar*
audience_app_get_cache_directory (AudienceApp* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_application_get_application_id ((GApplication*) self);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (_tmp0_, _tmp2_, NULL);
	result = _tmp3_;
	return result;
}

static void
audience_app_real_open (GApplication* base,
                        GFile** files,
                        gint files_length1,
                        const gchar* hint)
{
	AudienceApp * self;
	AudienceWindow* _tmp0_;
	self = (AudienceApp*) base;
	g_return_if_fail (hint != NULL);
	g_application_activate ((GApplication*) self);
	_tmp0_ = self->mainwindow;
	audience_window_open_files (_tmp0_, files, (gint) files_length1, TRUE, TRUE);
}

static GObject *
audience_app_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudienceApp * self;
	parent_class = G_OBJECT_CLASS (audience_app_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_APP, AudienceApp);
	setlocale (LC_ALL, "");
	g_application_set_application_id ((GApplication*) self, "io.elementary.videos");
	return obj;
}

static void
audience_app_class_init (AudienceAppClass * klass,
                         gpointer klass_data)
{
	audience_app_parent_class = g_type_class_peek_parent (klass);
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) audience_app_real_activate;
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) audience_app_real_open;
	G_OBJECT_CLASS (klass)->constructor = audience_app_constructor;
	G_OBJECT_CLASS (klass)->finalize = audience_app_finalize;
}

static void
audience_app_instance_init (AudienceApp * self,
                            gpointer klass)
{
}

static void
audience_app_finalize (GObject * obj)
{
	AudienceApp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_APP, AudienceApp);
	_g_object_unref0 (self->mainwindow);
	_g_object_unref0 (self->monitor);
	G_OBJECT_CLASS (audience_app_parent_class)->finalize (obj);
}

static GType
audience_app_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AudienceAppClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_app_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceApp), 0, (GInstanceInitFunc) audience_app_instance_init, NULL };
	GType audience_app_type_id;
	audience_app_type_id = g_type_register_static (gtk_application_get_type (), "AudienceApp", &g_define_type_info, 0);
	return audience_app_type_id;
}

GType
audience_app_get_type (void)
{
	static volatile gsize audience_app_type_id__volatile = 0;
	if (g_once_init_enter (&audience_app_type_id__volatile)) {
		GType audience_app_type_id;
		audience_app_type_id = audience_app_get_type_once ();
		g_once_init_leave (&audience_app_type_id__volatile, audience_app_type_id);
	}
	return audience_app_type_id__volatile;
}

void
_vala_main (gchar** args,
            gint args_length1)
{
	ClutterInitError err = 0;
	ClutterInitError _tmp0_;
	AudienceApp* app = NULL;
	AudienceApp* _tmp2_;
	XInitThreads ();
	_tmp0_ = gtk_clutter_init ((gint*) (&args_length1), &args);
	err = _tmp0_;
	if (err != CLUTTER_INIT_SUCCESS) {
		GEnumValue* _tmp1_;
		_tmp1_ = g_enum_get_value (g_type_class_ref (clutter_init_error_get_type ()), err);
		g_error ("Application.vala:96: Could not initialize clutter! %s", (_tmp1_ != NULL) ? _tmp1_->value_name : NULL);
	}
	gst_init ((gint*) (&args_length1), &args);
	_tmp2_ = audience_app_get_instance ();
	app = _tmp2_;
	g_application_run ((GApplication*) app, (gint) args_length1, args);
	_g_object_unref0 (app);
}

int
main (int argc,
      char ** argv)
{
	_vala_main (argv, argc);
	return 0;
}

