/* Utils.c generated by valac 0.48.6, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2013-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Tom Beckmann <tomjonabc@gmail.com>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gst/pbutils/pbutils.h>
#include <gst/gst.h>

#define TYPE_GNOME_MEDIA_KEYS (gnome_media_keys_get_type ())
#define GNOME_MEDIA_KEYS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GNOME_MEDIA_KEYS, GnomeMediaKeys))
#define IS_GNOME_MEDIA_KEYS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GNOME_MEDIA_KEYS))
#define GNOME_MEDIA_KEYS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GNOME_MEDIA_KEYS, GnomeMediaKeysIface))

typedef struct _GnomeMediaKeys GnomeMediaKeys;
typedef struct _GnomeMediaKeysIface GnomeMediaKeysIface;

#define TYPE_GNOME_MEDIA_KEYS_PROXY (gnome_media_keys_proxy_get_type ())
enum  {
	GNOME_MEDIA_KEYS_MEDIA_PLAYER_KEY_PRESSED_SIGNAL,
	GNOME_MEDIA_KEYS_NUM_SIGNALS
};
static guint gnome_media_keys_signals[GNOME_MEDIA_KEYS_NUM_SIGNALS] = {0};
typedef GDBusProxy GnomeMediaKeysProxy;
typedef GDBusProxyClass GnomeMediaKeysProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_GNOME_SESSION_MANAGER (gnome_session_manager_get_type ())
#define GNOME_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManager))
#define IS_GNOME_SESSION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GNOME_SESSION_MANAGER))
#define GNOME_SESSION_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_GNOME_SESSION_MANAGER, GnomeSessionManagerIface))

typedef struct _GnomeSessionManager GnomeSessionManager;
typedef struct _GnomeSessionManagerIface GnomeSessionManagerIface;

#define TYPE_GNOME_SESSION_MANAGER_PROXY (gnome_session_manager_proxy_get_type ())
typedef GDBusProxy GnomeSessionManagerProxy;
typedef GDBusProxyClass GnomeSessionManagerProxyClass;
typedef void (*AudienceFuncOverDir) (GFile* file_under_dir, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define AUDIENCE_TYPE_DISK_MANAGER (audience_disk_manager_get_type ())
#define AUDIENCE_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManager))
#define AUDIENCE_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))
#define AUDIENCE_IS_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_IS_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_DISK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))

typedef struct _AudienceDiskManager AudienceDiskManager;
typedef struct _AudienceDiskManagerClass AudienceDiskManagerClass;

struct _GnomeMediaKeysIface {
	GTypeInterface parent_iface;
	void (*grab_media_player_keys) (GnomeMediaKeys* self, const gchar* application, guint32 time, GError** error);
	void (*release_media_player_keys) (GnomeMediaKeys* self, const gchar* application, GError** error);
};

struct _GnomeSessionManagerIface {
	GTypeInterface parent_iface;
	gboolean (*is_session_running) (GnomeSessionManager* self, GError** error);
	guint32 (*inhibit) (GnomeSessionManager* self, const gchar* app_id, guint32 toplevel_xid, const gchar* reason, guint32 flags, GError** error);
	void (*uninhibit) (GnomeSessionManager* self, guint32 inhibit_cookie, GError** error);
};

GType gnome_media_keys_proxy_get_type (void) G_GNUC_CONST;
guint gnome_media_keys_register_object (void* object,
                                        GDBusConnection* connection,
                                        const gchar* path,
                                        GError** error);
GType gnome_media_keys_get_type (void) G_GNUC_CONST;
void gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                              const gchar* application,
                                              guint32 time,
                                              GError** error);
void gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                                 const gchar* application,
                                                 GError** error);
static void g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static GType gnome_media_keys_get_type_once (void);
static void gnome_media_keys_proxy_g_signal (GDBusProxy* proxy,
                                      const gchar* sender_name,
                                      const gchar* signal_name,
                                      GVariant* parameters);
static void _dbus_handle_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* self,
                                                             GVariant* parameters);
static void gnome_media_keys_proxy_grab_media_player_keys (GnomeMediaKeys* self,
                                                    const gchar* application,
                                                    guint32 time,
                                                    GError** error);
static void gnome_media_keys_proxy_release_media_player_keys (GnomeMediaKeys* self,
                                                       const gchar* application,
                                                       GError** error);
static void gnome_media_keys_proxy_gnome_media_keys_interface_init (GnomeMediaKeysIface* iface);
static void _dbus_gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                                    GVariant* _parameters_,
                                                    GDBusMethodInvocation* invocation);
static void _dbus_gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void gnome_media_keys_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data);
static GVariant* gnome_media_keys_dbus_interface_get_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GError** error,
                                                        gpointer user_data);
static gboolean gnome_media_keys_dbus_interface_set_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GVariant* value,
                                                       GError** error,
                                                       gpointer user_data);
static void _dbus_gnome_media_keys_media_player_key_pressed (GObject* _sender,
                                                      const gchar* application,
                                                      const gchar* key,
                                                      gpointer* _data);
static void _gnome_media_keys_unregister_object (gpointer user_data);
GType gnome_session_manager_proxy_get_type (void) G_GNUC_CONST;
guint gnome_session_manager_register_object (void* object,
                                             GDBusConnection* connection,
                                             const gchar* path,
                                             GError** error);
GType gnome_session_manager_get_type (void) G_GNUC_CONST;
gboolean gnome_session_manager_is_session_running (GnomeSessionManager* self,
                                                   GError** error);
guint32 gnome_session_manager_inhibit (GnomeSessionManager* self,
                                       const gchar* app_id,
                                       guint32 toplevel_xid,
                                       const gchar* reason,
                                       guint32 flags,
                                       GError** error);
void gnome_session_manager_uninhibit (GnomeSessionManager* self,
                                      guint32 inhibit_cookie,
                                      GError** error);
static GType gnome_session_manager_get_type_once (void);
static void gnome_session_manager_proxy_g_signal (GDBusProxy* proxy,
                                           const gchar* sender_name,
                                           const gchar* signal_name,
                                           GVariant* parameters);
static gboolean gnome_session_manager_proxy_is_session_running (GnomeSessionManager* self,
                                                         GError** error);
static guint32 gnome_session_manager_proxy_inhibit (GnomeSessionManager* self,
                                             const gchar* app_id,
                                             guint32 toplevel_xid,
                                             const gchar* reason,
                                             guint32 flags,
                                             GError** error);
static void gnome_session_manager_proxy_uninhibit (GnomeSessionManager* self,
                                            guint32 inhibit_cookie,
                                            GError** error);
static void gnome_session_manager_proxy_gnome_session_manager_interface_init (GnomeSessionManagerIface* iface);
static void _dbus_gnome_session_manager_is_session_running (GnomeSessionManager* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_gnome_session_manager_inhibit (GnomeSessionManager* self,
                                          GVariant* _parameters_,
                                          GDBusMethodInvocation* invocation);
static void _dbus_gnome_session_manager_uninhibit (GnomeSessionManager* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation);
static void gnome_session_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* method_name,
                                                       GVariant* parameters,
                                                       GDBusMethodInvocation* invocation,
                                                       gpointer user_data);
static GVariant* gnome_session_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data);
static gboolean gnome_session_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* property_name,
                                                            GVariant* value,
                                                            GError** error,
                                                            gpointer user_data);
static void _gnome_session_manager_unregister_object (gpointer user_data);
#define AUDIENCE_DISCOVERER_TIMEOUT 5
void audience_recurse_over_dir (GFile* file_to_process,
                                AudienceFuncOverDir func,
                                gpointer func_target);
gchar* audience_get_title (const gchar* filename);
gchar* audience_get_basename (const gchar* filename);
gchar* audience_get_extension (const gchar* filename);
gboolean audience_has_dvd (void);
GType audience_disk_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceDiskManager, g_object_unref)
AudienceDiskManager* audience_disk_manager_get_default (void);
GeeTreeSet* audience_disk_manager_get_volumes (AudienceDiskManager* self);
gboolean audience_file_exists (const gchar* uri);
GstDiscovererInfo* audience_get_discoverer_info (const gchar* uri);

static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_grab_media_player_keys_application = {-1, "application", "s", NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_grab_media_player_keys_time = {-1, "time", "u", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_grab_media_player_keys_in[] = {&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_application, &_gnome_media_keys_dbus_arg_info_grab_media_player_keys_time, NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_grab_media_player_keys_out[] = {NULL};
static const GDBusMethodInfo _gnome_media_keys_dbus_method_info_grab_media_player_keys = {-1, "GrabMediaPlayerKeys", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_in), (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_grab_media_player_keys_out), NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_release_media_player_keys_application = {-1, "application", "s", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_release_media_player_keys_in[] = {&_gnome_media_keys_dbus_arg_info_release_media_player_keys_application, NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_release_media_player_keys_out[] = {NULL};
static const GDBusMethodInfo _gnome_media_keys_dbus_method_info_release_media_player_keys = {-1, "ReleaseMediaPlayerKeys", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_release_media_player_keys_in), (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_release_media_player_keys_out), NULL};
static const GDBusMethodInfo * const _gnome_media_keys_dbus_method_info[] = {&_gnome_media_keys_dbus_method_info_grab_media_player_keys, &_gnome_media_keys_dbus_method_info_release_media_player_keys, NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_media_player_key_pressed_application = {-1, "application", "s", NULL};
static const GDBusArgInfo _gnome_media_keys_dbus_arg_info_media_player_key_pressed_key = {-1, "key", "s", NULL};
static const GDBusArgInfo * const _gnome_media_keys_dbus_arg_info_media_player_key_pressed[] = {&_gnome_media_keys_dbus_arg_info_media_player_key_pressed_application, &_gnome_media_keys_dbus_arg_info_media_player_key_pressed_key, NULL};
static const GDBusSignalInfo _gnome_media_keys_dbus_signal_info_media_player_key_pressed = {-1, "MediaPlayerKeyPressed", (GDBusArgInfo **) (&_gnome_media_keys_dbus_arg_info_media_player_key_pressed), NULL};
static const GDBusSignalInfo * const _gnome_media_keys_dbus_signal_info[] = {&_gnome_media_keys_dbus_signal_info_media_player_key_pressed, NULL};
static const GDBusPropertyInfo * const _gnome_media_keys_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gnome_media_keys_dbus_interface_info = {-1, "org.gnome.SettingsDaemon.MediaKeys", (GDBusMethodInfo **) (&_gnome_media_keys_dbus_method_info), (GDBusSignalInfo **) (&_gnome_media_keys_dbus_signal_info), (GDBusPropertyInfo **) (&_gnome_media_keys_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gnome_media_keys_dbus_interface_vtable = {gnome_media_keys_dbus_interface_method_call, gnome_media_keys_dbus_interface_get_property, gnome_media_keys_dbus_interface_set_property};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_is_session_running_result = {-1, "result", "b", NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_is_session_running_in[] = {NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_is_session_running_out[] = {&_gnome_session_manager_dbus_arg_info_is_session_running_result, NULL};
static const GDBusMethodInfo _gnome_session_manager_dbus_method_info_is_session_running = {-1, "isSessionRunning", (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_is_session_running_in), (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_is_session_running_out), NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_inhibit_app_id = {-1, "app_id", "s", NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_inhibit_toplevel_xid = {-1, "toplevel_xid", "u", NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_inhibit_reason = {-1, "reason", "s", NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_inhibit_flags = {-1, "flags", "u", NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_inhibit_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_inhibit_in[] = {&_gnome_session_manager_dbus_arg_info_inhibit_app_id, &_gnome_session_manager_dbus_arg_info_inhibit_toplevel_xid, &_gnome_session_manager_dbus_arg_info_inhibit_reason, &_gnome_session_manager_dbus_arg_info_inhibit_flags, NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_inhibit_out[] = {&_gnome_session_manager_dbus_arg_info_inhibit_result, NULL};
static const GDBusMethodInfo _gnome_session_manager_dbus_method_info_inhibit = {-1, "Inhibit", (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_inhibit_in), (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_inhibit_out), NULL};
static const GDBusArgInfo _gnome_session_manager_dbus_arg_info_uninhibit_inhibit_cookie = {-1, "inhibit_cookie", "u", NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_uninhibit_in[] = {&_gnome_session_manager_dbus_arg_info_uninhibit_inhibit_cookie, NULL};
static const GDBusArgInfo * const _gnome_session_manager_dbus_arg_info_uninhibit_out[] = {NULL};
static const GDBusMethodInfo _gnome_session_manager_dbus_method_info_uninhibit = {-1, "Uninhibit", (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_uninhibit_in), (GDBusArgInfo **) (&_gnome_session_manager_dbus_arg_info_uninhibit_out), NULL};
static const GDBusMethodInfo * const _gnome_session_manager_dbus_method_info[] = {&_gnome_session_manager_dbus_method_info_is_session_running, &_gnome_session_manager_dbus_method_info_inhibit, &_gnome_session_manager_dbus_method_info_uninhibit, NULL};
static const GDBusSignalInfo * const _gnome_session_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _gnome_session_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _gnome_session_manager_dbus_interface_info = {-1, "org.gnome.SessionManager", (GDBusMethodInfo **) (&_gnome_session_manager_dbus_method_info), (GDBusSignalInfo **) (&_gnome_session_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_gnome_session_manager_dbus_property_info), NULL};
static const GDBusInterfaceVTable _gnome_session_manager_dbus_interface_vtable = {gnome_session_manager_dbus_interface_method_call, gnome_session_manager_dbus_interface_get_property, gnome_session_manager_dbus_interface_set_property};

void
gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                         const gchar* application,
                                         guint32 time,
                                         GError** error)
{
	g_return_if_fail (self != NULL);
	GNOME_MEDIA_KEYS_GET_INTERFACE (self)->grab_media_player_keys (self, application, time, error);
}

void
gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                            const gchar* application,
                                            GError** error)
{
	g_return_if_fail (self != NULL);
	GNOME_MEDIA_KEYS_GET_INTERFACE (self)->release_media_player_keys (self, application, error);
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
gnome_media_keys_default_init (GnomeMediaKeysIface * iface,
                               gpointer iface_data)
{
	gnome_media_keys_signals[GNOME_MEDIA_KEYS_MEDIA_PLAYER_KEY_PRESSED_SIGNAL] = g_signal_new ("media-player-key-pressed", TYPE_GNOME_MEDIA_KEYS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING, G_TYPE_NONE, 2, G_TYPE_STRING, G_TYPE_STRING);
}

static GType
gnome_media_keys_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnomeMediaKeysIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_media_keys_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gnome_media_keys_type_id;
	gnome_media_keys_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomeMediaKeys", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gnome_media_keys_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gnome_media_keys_proxy_get_type);
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SettingsDaemon.MediaKeys");
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gnome_media_keys_dbus_interface_info));
	g_type_set_qdata (gnome_media_keys_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gnome_media_keys_register_object);
	return gnome_media_keys_type_id;
}

GType
gnome_media_keys_get_type (void)
{
	static volatile gsize gnome_media_keys_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_media_keys_type_id__volatile)) {
		GType gnome_media_keys_type_id;
		gnome_media_keys_type_id = gnome_media_keys_get_type_once ();
		g_once_init_leave (&gnome_media_keys_type_id__volatile, gnome_media_keys_type_id);
	}
	return gnome_media_keys_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (GnomeMediaKeysProxy, gnome_media_keys_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_GNOME_MEDIA_KEYS, gnome_media_keys_proxy_gnome_media_keys_interface_init) )
static void
gnome_media_keys_proxy_class_init (GnomeMediaKeysProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = gnome_media_keys_proxy_g_signal;
}

static void
_dbus_handle_gnome_media_keys_media_player_key_pressed (GnomeMediaKeys* self,
                                                        GVariant* parameters)
{
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp0_;
	gchar* key = NULL;
	GVariant* _tmp1_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	key = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	g_signal_emit_by_name (self, "media-player-key-pressed", application, key);
	_g_free0 (application);
	_g_free0 (key);
}

static void
gnome_media_keys_proxy_g_signal (GDBusProxy* proxy,
                                 const gchar* sender_name,
                                 const gchar* signal_name,
                                 GVariant* parameters)
{
	if (strcmp (signal_name, "MediaPlayerKeyPressed") == 0) {
		_dbus_handle_gnome_media_keys_media_player_key_pressed ((GnomeMediaKeys*) proxy, parameters);
	}
}

static void
gnome_media_keys_proxy_init (GnomeMediaKeysProxy* self)
{
}

static void
gnome_media_keys_proxy_grab_media_player_keys (GnomeMediaKeys* self,
                                               const gchar* application,
                                               guint32 time,
                                               GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SettingsDaemon.MediaKeys", "GrabMediaPlayerKeys");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (time));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
gnome_media_keys_proxy_release_media_player_keys (GnomeMediaKeys* self,
                                                  const gchar* application,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SettingsDaemon.MediaKeys", "ReleaseMediaPlayerKeys");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
gnome_media_keys_proxy_gnome_media_keys_interface_init (GnomeMediaKeysIface* iface)
{
	iface->grab_media_player_keys = gnome_media_keys_proxy_grab_media_player_keys;
	iface->release_media_player_keys = gnome_media_keys_proxy_release_media_player_keys;
}

static void
_dbus_gnome_media_keys_grab_media_player_keys (GnomeMediaKeys* self,
                                               GVariant* _parameters_,
                                               GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp2_;
	guint32 time = 0U;
	GVariant* _tmp3_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	time = g_variant_get_uint32 (_tmp3_);
	g_variant_unref (_tmp3_);
	gnome_media_keys_grab_media_player_keys (self, application, time, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (application);
}

static void
_dbus_gnome_media_keys_release_media_player_keys (GnomeMediaKeys* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* application = NULL;
	GVariant* _tmp4_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp4_ = g_variant_iter_next_value (&_arguments_iter);
	application = g_variant_dup_string (_tmp4_, NULL);
	g_variant_unref (_tmp4_);
	gnome_media_keys_release_media_player_keys (self, application, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (application);
}

static void
gnome_media_keys_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GrabMediaPlayerKeys") == 0) {
		_dbus_gnome_media_keys_grab_media_player_keys (object, parameters, invocation);
	} else if (strcmp (method_name, "ReleaseMediaPlayerKeys") == 0) {
		_dbus_gnome_media_keys_release_media_player_keys (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
gnome_media_keys_dbus_interface_get_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
gnome_media_keys_dbus_interface_set_property (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* property_name,
                                              GVariant* value,
                                              GError** error,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_gnome_media_keys_media_player_key_pressed (GObject* _sender,
                                                 const gchar* application,
                                                 const gchar* key,
                                                 gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (application));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (key));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.SettingsDaemon.MediaKeys", "MediaPlayerKeyPressed", _arguments, NULL);
}

guint
gnome_media_keys_register_object (gpointer object,
                                  GDBusConnection* connection,
                                  const gchar* path,
                                  GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gnome_media_keys_dbus_interface_info), &_gnome_media_keys_dbus_interface_vtable, data, _gnome_media_keys_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "media-player-key-pressed", (GCallback) _dbus_gnome_media_keys_media_player_key_pressed, data);
	return result;
}

static void
_gnome_media_keys_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_gnome_media_keys_media_player_key_pressed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

gboolean
gnome_session_manager_is_session_running (GnomeSessionManager* self,
                                          GError** error)
{
	g_return_val_if_fail (self != NULL, FALSE);
	return GNOME_SESSION_MANAGER_GET_INTERFACE (self)->is_session_running (self, error);
}

guint32
gnome_session_manager_inhibit (GnomeSessionManager* self,
                               const gchar* app_id,
                               guint32 toplevel_xid,
                               const gchar* reason,
                               guint32 flags,
                               GError** error)
{
	g_return_val_if_fail (self != NULL, 0U);
	return GNOME_SESSION_MANAGER_GET_INTERFACE (self)->inhibit (self, app_id, toplevel_xid, reason, flags, error);
}

void
gnome_session_manager_uninhibit (GnomeSessionManager* self,
                                 guint32 inhibit_cookie,
                                 GError** error)
{
	g_return_if_fail (self != NULL);
	GNOME_SESSION_MANAGER_GET_INTERFACE (self)->uninhibit (self, inhibit_cookie, error);
}

static void
gnome_session_manager_default_init (GnomeSessionManagerIface * iface,
                                    gpointer iface_data)
{
}

static GType
gnome_session_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GnomeSessionManagerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_session_manager_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType gnome_session_manager_type_id;
	gnome_session_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "GnomeSessionManager", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (gnome_session_manager_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) gnome_session_manager_proxy_get_type);
	g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.SessionManager");
	g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_gnome_session_manager_dbus_interface_info));
	g_type_set_qdata (gnome_session_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) gnome_session_manager_register_object);
	return gnome_session_manager_type_id;
}

GType
gnome_session_manager_get_type (void)
{
	static volatile gsize gnome_session_manager_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_session_manager_type_id__volatile)) {
		GType gnome_session_manager_type_id;
		gnome_session_manager_type_id = gnome_session_manager_get_type_once ();
		g_once_init_leave (&gnome_session_manager_type_id__volatile, gnome_session_manager_type_id);
	}
	return gnome_session_manager_type_id__volatile;
}

G_DEFINE_TYPE_EXTENDED (GnomeSessionManagerProxy, gnome_session_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_GNOME_SESSION_MANAGER, gnome_session_manager_proxy_gnome_session_manager_interface_init) )
static void
gnome_session_manager_proxy_class_init (GnomeSessionManagerProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = gnome_session_manager_proxy_g_signal;
}

static void
gnome_session_manager_proxy_g_signal (GDBusProxy* proxy,
                                      const gchar* sender_name,
                                      const gchar* signal_name,
                                      GVariant* parameters)
{
}

static void
gnome_session_manager_proxy_init (GnomeSessionManagerProxy* self)
{
}

static gboolean
gnome_session_manager_proxy_is_session_running (GnomeSessionManager* self,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gboolean _result = FALSE;
	GVariant* _tmp7_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "isSessionRunning");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gboolean _tmp5_ = FALSE;
		return _tmp5_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gboolean _tmp6_ = FALSE;
		g_object_unref (_reply_message);
		return _tmp6_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp7_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_boolean (_tmp7_);
	g_variant_unref (_tmp7_);
	g_object_unref (_reply_message);
	return _result;
}

static guint32
gnome_session_manager_proxy_inhibit (GnomeSessionManager* self,
                                     const gchar* app_id,
                                     guint32 toplevel_xid,
                                     const gchar* reason,
                                     guint32 flags,
                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp10_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Inhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (toplevel_xid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (reason));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (flags));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		guint32 _tmp8_ = 0U;
		return _tmp8_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp9_ = 0U;
		g_object_unref (_reply_message);
		return _tmp9_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp10_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp10_);
	g_variant_unref (_tmp10_);
	g_object_unref (_reply_message);
	return _result;
}

static void
gnome_session_manager_proxy_uninhibit (GnomeSessionManager* self,
                                       guint32 inhibit_cookie,
                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.SessionManager", "Uninhibit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (inhibit_cookie));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
gnome_session_manager_proxy_gnome_session_manager_interface_init (GnomeSessionManagerIface* iface)
{
	iface->is_session_running = gnome_session_manager_proxy_is_session_running;
	iface->inhibit = gnome_session_manager_proxy_inhibit;
	iface->uninhibit = gnome_session_manager_proxy_uninhibit;
}

static void
_dbus_gnome_session_manager_is_session_running (GnomeSessionManager* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gboolean result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	result = gnome_session_manager_is_session_running (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_boolean (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_gnome_session_manager_inhibit (GnomeSessionManager* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* app_id = NULL;
	GVariant* _tmp11_;
	guint32 toplevel_xid = 0U;
	GVariant* _tmp12_;
	gchar* reason = NULL;
	GVariant* _tmp13_;
	guint32 flags = 0U;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp11_ = g_variant_iter_next_value (&_arguments_iter);
	app_id = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	_tmp12_ = g_variant_iter_next_value (&_arguments_iter);
	toplevel_xid = g_variant_get_uint32 (_tmp12_);
	g_variant_unref (_tmp12_);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	flags = g_variant_get_uint32 (_tmp14_);
	g_variant_unref (_tmp14_);
	result = gnome_session_manager_inhibit (self, app_id, toplevel_xid, reason, flags, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (app_id);
	_g_free0 (reason);
}

static void
_dbus_gnome_session_manager_uninhibit (GnomeSessionManager* self,
                                       GVariant* _parameters_,
                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint32 inhibit_cookie = 0U;
	GVariant* _tmp15_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	inhibit_cookie = g_variant_get_uint32 (_tmp15_);
	g_variant_unref (_tmp15_);
	gnome_session_manager_uninhibit (self, inhibit_cookie, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
gnome_session_manager_dbus_interface_method_call (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* method_name,
                                                  GVariant* parameters,
                                                  GDBusMethodInvocation* invocation,
                                                  gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "isSessionRunning") == 0) {
		_dbus_gnome_session_manager_is_session_running (object, parameters, invocation);
	} else if (strcmp (method_name, "Inhibit") == 0) {
		_dbus_gnome_session_manager_inhibit (object, parameters, invocation);
	} else if (strcmp (method_name, "Uninhibit") == 0) {
		_dbus_gnome_session_manager_uninhibit (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
gnome_session_manager_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
gnome_session_manager_dbus_interface_set_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GVariant* value,
                                                   GError** error,
                                                   gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
gnome_session_manager_register_object (gpointer object,
                                       GDBusConnection* connection,
                                       const gchar* path,
                                       GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_gnome_session_manager_dbus_interface_info), &_gnome_session_manager_dbus_interface_vtable, data, _gnome_session_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_gnome_session_manager_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

void
audience_recurse_over_dir (GFile* file_to_process,
                           AudienceFuncOverDir func,
                           gpointer func_target)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (file_to_process != NULL);
	if (g_file_query_file_type (file_to_process, 0, NULL) == G_FILE_TYPE_DIRECTORY) {
		{
			GFileEnumerator* files = NULL;
			GFileEnumerator* _tmp0_;
			GFileInfo* info = NULL;
			_tmp0_ = g_file_enumerate_children (file_to_process, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_ACCESS_CAN_READ, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
			files = _tmp0_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			while (TRUE) {
				GFileInfo* _tmp1_ = NULL;
				GFileEnumerator* _tmp2_;
				GFileInfo* _tmp3_;
				GFileInfo* _tmp4_;
				GFileInfo* _tmp5_;
				GFile* file = NULL;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				GFileInfo* _tmp10_;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				GFile* _tmp16_;
				_tmp2_ = files;
				_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
				_tmp1_ = _tmp3_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (info);
					_g_object_unref0 (files);
					goto __catch0_g_error;
				}
				_tmp4_ = _tmp1_;
				_tmp1_ = NULL;
				_g_object_unref0 (info);
				info = _tmp4_;
				_tmp5_ = info;
				if (!(_tmp5_ != NULL)) {
					_g_object_unref0 (_tmp1_);
					break;
				}
				_tmp6_ = g_file_get_uri (file_to_process);
				_tmp7_ = _tmp6_;
				_tmp8_ = g_strconcat (_tmp7_, "/", NULL);
				_tmp9_ = _tmp8_;
				_tmp10_ = info;
				_tmp11_ = g_file_info_get_name (_tmp10_);
				_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_file_new_for_uri (_tmp13_);
				_tmp15_ = _tmp14_;
				_g_free0 (_tmp13_);
				_g_free0 (_tmp9_);
				_g_free0 (_tmp7_);
				file = _tmp15_;
				_tmp16_ = file;
				audience_recurse_over_dir (_tmp16_, func, func_target);
				_g_object_unref0 (file);
				_g_object_unref0 (_tmp1_);
			}
			_g_object_unref0 (info);
			_g_object_unref0 (files);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp17_;
			const gchar* _tmp18_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp17_ = e;
			_tmp18_ = _tmp17_->message;
			g_critical ("Utils.vala:49: %s", _tmp18_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	} else {
		func (file_to_process, func_target);
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
audience_get_title (const gchar* filename)
{
	gchar* title = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = audience_get_basename (filename);
	title = _tmp0_;
	_tmp1_ = title;
	_tmp2_ = g_uri_unescape_string (_tmp1_, NULL);
	_g_free0 (title);
	title = _tmp2_;
	_tmp3_ = title;
	_tmp4_ = string_replace (_tmp3_, "_", " ");
	_tmp5_ = _tmp4_;
	_tmp6_ = string_replace (_tmp5_, ".", " ");
	_tmp7_ = _tmp6_;
	_tmp8_ = string_replace (_tmp7_, "  ", " ");
	_g_free0 (title);
	title = _tmp8_;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	result = title;
	return result;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result = 0L;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

gchar*
audience_get_extension (const gchar* filename)
{
	gchar* _tmp5_;
	gchar* result = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	{
		guint i = 0U;
		gint _tmp0_;
		gint _tmp1_;
		_tmp0_ = strlen (filename);
		_tmp1_ = _tmp0_;
		i = (guint) _tmp1_;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				if (!_tmp2_) {
					guint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ - 1;
				}
				_tmp2_ = FALSE;
				if (!(i != ((guint) 0))) {
					break;
				}
				if (string_get (filename, (glong) i) == '.') {
					gchar* _tmp4_;
					_tmp4_ = string_substring (filename, (glong) (i + 1), (glong) -1);
					result = _tmp4_;
					return result;
				}
			}
		}
	}
	_tmp5_ = g_strdup (filename);
	result = _tmp5_;
	return result;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

gchar*
audience_get_basename (const gchar* filename)
{
	gchar* basename = NULL;
	gchar* _tmp0_;
	gint index_of_last_dot = 0;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* launcher_base = NULL;
	gchar* _tmp7_;
	gchar* result = NULL;
	g_return_val_if_fail (filename != NULL, NULL);
	_tmp0_ = g_path_get_basename (filename);
	basename = _tmp0_;
	_tmp1_ = basename;
	index_of_last_dot = string_last_index_of (_tmp1_, ".", 0);
	if (index_of_last_dot >= 0) {
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = basename;
		_tmp4_ = string_slice (_tmp3_, (glong) 0, (glong) index_of_last_dot);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp4_;
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = basename;
		_tmp6_ = g_strdup (_tmp5_);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp6_;
	}
	_tmp7_ = g_strdup (_tmp2_);
	launcher_base = _tmp7_;
	result = launcher_base;
	_g_free0 (_tmp2_);
	_g_free0 (basename);
	return result;
}

gboolean
audience_has_dvd (void)
{
	AudienceDiskManager* _tmp0_;
	AudienceDiskManager* _tmp1_;
	GeeTreeSet* _tmp2_;
	GeeTreeSet* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean result = FALSE;
	_tmp0_ = audience_disk_manager_get_default ();
	_tmp1_ = _tmp0_;
	_tmp2_ = audience_disk_manager_get_volumes (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_collection_get_is_empty ((GeeCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = !_tmp5_;
	_g_object_unref0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	result = _tmp6_;
	return result;
}

gboolean
audience_file_exists (const gchar* uri)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (uri != NULL, FALSE);
	_tmp0_ = g_file_new_for_uri (uri);
	file = _tmp0_;
	result = g_file_query_exists (file, NULL);
	_g_object_unref0 (file);
	return result;
}

GstDiscovererInfo*
audience_get_discoverer_info (const gchar* uri)
{
	GstDiscoverer* discoverer = NULL;
	GstDiscovererInfo* discoverer_info = NULL;
	GError* _inner_error0_ = NULL;
	GstDiscovererInfo* result = NULL;
	g_return_val_if_fail (uri != NULL, NULL);
	discoverer = NULL;
	{
		GstDiscoverer* _tmp0_ = NULL;
		GstDiscoverer* _tmp1_;
		GstDiscoverer* _tmp2_;
		_tmp1_ = gst_discoverer_new ((GstClockTime) (AUDIENCE_DISCOVERER_TIMEOUT * GST_SECOND), &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (discoverer);
		discoverer = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_debug ("Utils.vala:95: Could not create Gst discoverer object: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (discoverer);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	discoverer_info = NULL;
	{
		GstDiscovererInfo* _tmp5_ = NULL;
		GstDiscoverer* _tmp6_;
		GstDiscovererInfo* _tmp7_;
		GstDiscovererInfo* _tmp8_;
		_tmp6_ = discoverer;
		_tmp7_ = gst_discoverer_discover_uri (_tmp6_, uri, &_inner_error0_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (discoverer_info);
		discoverer_info = _tmp8_;
		_g_object_unref0 (_tmp5_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = e;
		_tmp10_ = e;
		_tmp11_ = _tmp10_->message;
		g_debug ("Utils.vala:102: Discoverer Error %d: %s\n", _tmp9_->code, _tmp11_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (discoverer_info);
		_g_object_unref0 (discoverer);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = discoverer_info;
	_g_object_unref0 (discoverer);
	return result;
}

